<?php

  chdir('../../../../'); //admin root
  require('includes/application_top.php');
  require('../includes/languages/' . $language . '/modules/payment/paypal_rest.php');
  require('../includes/modules/payment/paypal_rest.php');

  $action = (isset($HTTP_GET_VARS['action']) ? $HTTP_GET_VARS['action'] : '');
  $get = $HTTP_GET_VARS;
  $set = 'payment';
  $module_type = $cfgModules->get($set, 'code');
  $module_directory = $cfgModules->get($set, 'directory');
  $module_language_directory = $cfgModules->get($set, 'language_directory');
  $module_key = $cfgModules->get($set, 'key');
  
  $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
  $class = 'paypal_rest';
  if (!class_exists($class)) {
    include_once($module_directory . $class . $file_extension);
  }
  $module = new $class;

  switch ($action) {
    case 'save_merchant':
        $psid = '';
        if (!empty($HTTP_GET_VARS['psi_id'])) {
            $psid = '&psi_id=' . $HTTP_GET_VARS['psi_id'];
            if (!empty($HTTP_GET_VARS['merchantId'])) {
                $data = array(
                  'email_address' => $HTTP_GET_VARS['merchantId']
                );
                tep_db_perform('paypal_seller_info', $data, 'update', "psi_id='" . $HTTP_GET_VARS['psi_id'] . "'");
            }
        }
        tep_redirect(tep_href_link(FILENAME_MODULES, 'set=payment&action=edit&module=paypal_rest&ppp_next=4' . $psid));
        break;

    case 'install':
      // install module
        /*if ($module->check() > 0) { // remove module if already installed
          $module->remove();
        }*/

        $module->install();

        $modules_installed = explode(';', constant($module_key));

        if (!in_array($class . $file_extension, $modules_installed)) {
          $modules_installed[] = $class . $file_extension;
        }
        tep_db_query("update " . TABLE_CONFIGURATION . " set configuration_value = '" . implode(';', $modules_installed) . "' where configuration_key = '" . $module_key . "'");
        echo json_encode(['status' => "ok"]);
        die;
        
        break;

    case 'links':

        $psi_id = $HTTP_POST_VARS['psi_id']??false;

        $tmp = $module->getInstallOptions(false);
        $ret = [
          'live' => 'https://www.paypal.com/bizsignup/partner/entry?partnerClientId=' . $tmp['link_params']['partnerClientId'] . '&partnerId=' . $tmp['link_params']['partnerId'] . '&displayMode=minibrowser&partnerLogoUrl=' . $tmp['link_params']['partnerLogoUrl'] . '&returnToPartnerUrl=' . $tmp['link_params']['return_url'] . '&integrationType=FO&features=PAYMENT&country.x=' . $tmp['link_params']['country'] . '&locale.x=' . $tmp['link_params']['locale'] . '&product=ppcp&sellerNonce=' . $tmp['link_params']['sellerNonce'],
          'sandbox' => 'https://www.sandbox.paypal.com/bizsignup/partner/entry?partnerClientId=' . $tmp['link_params_sandbox']['partnerClientId'] . '&partnerId=' . $tmp['link_params_sandbox']['partnerId'] . '&displayMode=minibrowser&partnerLogoUrl=' . $tmp['link_params_sandbox']['partnerLogoUrl'] . '&returnToPartnerUrl=' . $tmp['link_params_sandbox']['return_url'] . '&integrationType=FO&features=PAYMENT&country.x=' . $tmp['link_params_sandbox']['country'] . '&locale.x=' . $tmp['link_params_sandbox']['locale'] . '&product=ppcp&sellerNonce=' . $tmp['link_params_sandbox']['sellerNonce'],
        ];
        unset($tmp['link_params']);
        unset($tmp['link_params_sandbox']);
        $ret = $tmp + $ret;


        echo json_encode($ret);
        die;
        break;


    case 'status':
        $ret = ['installPPP' => false];

        $class = 'paypal_rest';
        if (class_exists($class)) {
            $module  = new paypal_rest();
            $ret = $module->getInstallOptions();
        }

        echo json_encode($ret);
        die;
      break;

    case 'processOnBoard':
        if (($get['subaction']??'')=='checkDetails') {
            $ret = $module->validateCredentials($_POST);
//                }  else {
//                    $ret = ['html' => $module->onBoardingProcess()];
        }
        echo json_encode($ret);
        die;

        break;

    case 'saveExtra':

        $mode = $HTTP_POST_VARS['configuration']['MODULE_PAYMENT_PAYPAL_REST_TRANSACTION_SERVER'];
        $psi_id = ($_POST['psi_id']??($_GET['psi_id']??false));
        if ($psi_id) {
            $seller = $module->getSellerById((int)$psi_id);
            if ($psi_id !=$seller->psi_id) {
                unset($_POST['psi_id']);
            }
        }
        $partnerId = $module->getPartnerId($mode);
        if (empty($seller->psi_id) || $psi_id !=$seller->psi_id || $seller->partner_id != $partnerId || $mode != MODULE_PAYMENT_PAYPAL_REST_TRANSACTION_SERVER ) {
            $seller = $module->getSeller($mode);
        }
        $extra = new PaypalPartner\ExtraConfig([]);
        $extra->module = $module;

        $extra->saveExtra($seller);

//default from modules
        reset($HTTP_POST_VARS['configuration']);
        while (list($key, $value) = each($HTTP_POST_VARS['configuration'])) {
          tep_db_query("update " . TABLE_CONFIGURATION . " set configuration_value = '" . $value . "' where configuration_key = '" . $key . "'");
        }
        tep_redirect(tep_href_link(FILENAME_MODULES, 'set=' . $set . '&module=paypal_rest'));
      break;


            case 'sellerDetails':
                $module->fetchOwnKeys();
                echo json_encode(['reload' => 1, 'params' => 'set=payment&module=' . $module->code]);
                die;

                break;
            case 'checkOnBoarded':
                $module->checkOnBoarded();
                if ($get['result'] == 'show') {
                    $extra = $module->getExtraConfigClass();
                    echo $extra::widget([
                      'module' => $module,
                      'mode' => 'info',
                      'errors' => $module->errors,
                      'messages' => $module->messages,
                    ]);
                }
        echo json_encode(['status' => "ok"]);
        die;

        break;

        case 'deleteSeller':

            $seller = $module->getSeller();
            $ck = $get['ck']??'';
            if (!$seller->isNewRecord && $ck == $seller->tracking_id) {

                //delete seller after new details save.
                //$seller->delete();
                //echo "<div classs='popup-wrap'>Deleted</div><script>window.location.reload()</script>";

                //cleanup temp sellers (could be finished connection)
                PaypalPartner\models\SellerInfo::deleteAll('status=-1 and own_client_secret<>"" and own_client_id<>"" ');
                $seller = $module->getSeller(false, true);
            }

            //tep_redirect(tep_href_link(FILENAME_MODULES, 'set=' . $set . '&module=' . $module->code . '&psi_id=' . $seller->psi_id));
            tep_redirect(tep_href_link(FILENAME_MODULES, 'set=' . $set . '&module=' . $module->code . '&action=edit&ppp_next=4&psi_id=' . $seller->psi_id));
            
            die;

        break;
            case 'subscribeSeller':
                $platformId = $module->getPlatformId();
                $seller = $module->getSeller($platformId);
                $ck = $get['ck']??'';
                if (!$seller->isNewRecord && $ck == $seller->tracking_id) {
                    $module->addWebHooks();
                }
            tep_redirect(tep_href_link(FILENAME_MODULES, 'set=' . $set . '&module=' . $module->code . '&action=edit&setup=2&ppp_next=4&psi_id=' . $seller->psi_id));

            die;

        break;



    default:
      die;
      break;
  }

  require(DIR_WS_INCLUDES . 'template_top.php');
  require(DIR_WS_INCLUDES . 'template_bottom.php');
  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
