<?php

  chdir('../../../../');
  require('includes/application_top.php');

  global $customer_default_address_id;
  if (!tep_session_is_registered('customer_default_address_id')) {
      tep_session_register('customer_default_address_id');
  }
  
  require_once(DIR_WS_CLASSES . 'order.php');
  require_once(DIR_WS_CLASSES . 'shipping.php');
  require_once(DIR_WS_CLASSES . 'payment.php');
  require_once(DIR_WS_CLASSES . 'order_total.php');

  require(DIR_WS_LANGUAGES . $language . '/modules/payment/paypal_rest.php');
  //require(DIR_WS_LANGUAGES . $language . '/' . FILENAME_CREATE_ACCOUNT);

  require('includes/modules/payment/paypal_rest.php');
  $paypal_rest = new paypal_rest();

  if (!tep_session_is_registered('payment')) tep_session_register('payment');
  if (empty($payment)) {
      $payment = 'paypal_rest';
  }

  if (!tep_session_is_registered('cartID')) tep_session_register('cartID');
  //$order = new order;
  //$payment_modules = new payment($payment);

  $action = (isset($HTTP_GET_VARS['action']) ? $HTTP_GET_VARS['action'] : '');
  $subaction = (isset($HTTP_GET_VARS['subaction']) ? $HTTP_GET_VARS['subaction'] : '');
  $get = $_GET;

  //if ($action == 'callback') {
    switch ($action) {

            case 'sellerDetails':
                $paypal_rest->fetchOwnKeys();
                $ret = ['reload' => 1, 'params' => 'set=paymen&action=edit&module=paypal_rest'];
                echo json_encode($ret);
                break;

            case 'returnAPM':
                echo $paypal_rest->returnAPM($get['method']);
                break;
            case 'cancelAPM':
                echo $paypal_rest->cancelAPM($get['method']);
                break;
            case 'processWebhook':
                echo $paypal_rest->onProcessWebhook();
                break;

            case 'customerDetails':

                if (!tep_session_is_registered('comments')) tep_session_register('comments');
                if (isset($HTTP_POST_VARS['comments']) && tep_not_null($HTTP_POST_VARS['comments'])) {
                    $comments = tep_db_prepare_input($HTTP_POST_VARS['comments']);
                }

                $ret = [];
                if (!empty($get['option']) && $get['option']=='card') {
                    $ret = $paypal_rest->generateCCCustomerDetails();
                }
                echo json_encode($ret);
                break;
            case 'createOrder':
                $data = $_POST;
                if (!empty($_GET['restart']) || (!empty($_GET['page']) && $_GET['page']!='checkout')) {
                    $data['restart'] = 1;
                    $cartID = $cart->cartID = $cart->generate_cart_id();
                }
                
                if ($_GET['page'] == 'checkout') {
                    $paypal_rest->resetSession('estimate_ship');
                    $paypal_rest->resetSession('estimate_bill');
                    //$this->resetSession('select_shipping');
                }
                
                $pRes = $paypal_rest->createOrder($data);
                $response = [];
                if (is_object($pRes) && is_object($pRes->result)) {
                    $response['id'] = $pRes->result->id;
                    if (!empty($get['option'])) {
                        $response = $paypal_rest->validateAPMCreateOrderResponse($get['option'], $pRes);
                    }

                } elseif (is_array($pRes) && !empty($pRes['error']) ) {
                    $response = $pRes;
                }
                echo json_encode($response);
                break;
            case 'retrieveOrder':
                //if PP order is OK -  login/create customer, select/add addresses, save details and go to checkout/process
                // pickup: reset shipping address in the PP order (it's set after login by default) and cause error during auth/capture.
                $orderId = $_GET['id'];

                $paypal_rest->setSession('partner_order_pending', false);
                $json = [];
                if ($orderId) {
                    $order = $paypal_rest->createOrderInstance();
                    $response = $paypal_rest->getOrder($orderId);
$paypal_rest::debug(print_r($response, true), 'retrieveOrderResponse');

                    if (!empty($response->result->status) &&
                        (in_array(strtoupper($response->result->status), ['CREATED', 'APPROVED'])
                        ||
                        ( strtoupper($response->result->status) == 'PENDING_APPROVAL' && !empty($response->result->payment_source->pay_upon_invoice)
                            && !empty($response->result->processing_instruction) && $response->result->processing_instruction == 'ORDER_COMPLETE_ON_PAYMENT_APPROVAL'
                            )
                        )
                        ) {
                        if ( strtoupper($response->result->status) == 'PENDING_APPROVAL' && !empty($response->result->payment_source->pay_upon_invoice)
                            && !empty($response->result->processing_instruction) && $response->result->processing_instruction == 'ORDER_COMPLETE_ON_PAYMENT_APPROVAL'
                            ) {
                            $paypal_rest->getSession('partner_order_pending');
                            $paypal_rest->setSession('partner_order_pending', 'pay_upon_invoice');
                        }
                        $updateAddress = false;
///2DO no $payer in card payments!!
                        $payer = $response->result->payer;
                        if (!$paypal_rest->isCustomerAssigned()) {
                            $paypal_rest::debug('customer not assigned');
                            $customer = $paypal_rest->getCustomerByEmail($payer->email_address);
                            $paypal_rest::debug('customer serch by email' . print_r($customer, true));
                            if (empty($customer->customers_id)) {
                                // create  new account
                                $customer = $paypal_rest->getCustomersIdentity();

                                $customer->load([
                                  'customers_newsletter' => 0,
                                  'customers_email_address' => $payer->email_address,
                                  'customers_firstname' => $payer->name->given_name,
                                  'customers_lastname' => $payer->name->surname,
                                ]);
                                $customer->save();
                                $paypal_rest::debug('customer created ' . print_r($customer, true));
                               
                                $updateAddress = true;
                            }
                            $paypal_rest->setSession('customer_id', $customer->customers_id);
                        } else {
                            $customer = $paypal_rest->getCustomersIdentity();
                            $paypal_rest::debug('customer assigned ' . print_r($customer, true));
                        }

                        if (isset($customer->customers_telephone) && trim($customer->customers_telephone) == '' && isset($payer->phone) && isset($payer->phone->phone_number) && isset($payer->phone->phone_number->national_number) && trim($payer->phone->phone_number->national_number) != '') {
                            $customer->customers_telephone = $payer->phone->phone_number->national_number;
                            $customer->save(false);
                        }

                        $payerAddresses = [];
                        $payerAddresses['billto'] = $response->result->payer->address??(new \stdClass());
                        if (!empty($payerAddresses['billto']) && count((array)$payerAddresses['billto'])>2) {
                            $payerAddresses['billto']->firstname = $payer->name->given_name;
                            $payerAddresses['billto']->lastname = $payer->name->surname;
                        }

                        $payerAddresses['sendto'] = $response->result->purchase_units[0]->shipping->address??(new \stdClass());
                        if (!empty($response->result->purchase_units[0]->shipping->name->full_name)) {
                            $_tmp = explode(' ', $response->result->purchase_units[0]->shipping->name->full_name, 2);
                            $payerAddresses['sendto']->firstname = $_tmp[0]??'';
                            $payerAddresses['sendto']->lastname = $_tmp[1]??'';
                        } else {
                            $payerAddresses['sendto']->firstname = $payer->name->given_name;
                            $payerAddresses['sendto']->lastname = $payer->name->surname;
                        }
                        $sendto = $billto = false;
                        foreach ($payerAddresses as $type => $payerAddress) {
                            if (!empty($payerAddress) && count((array)$payerAddress)>2) {
                                $country = $paypal_rest::get_country_info_by_iso($payerAddress->country_code);
                                $ship_zone_id = 0;
                                $ship_zone = $payerAddress->admin_area_1;
                                $zone = $paypal_rest::get_zone_info_by_title($payerAddress->admin_area_1, $country['id']);
                                if ($zone) {
                                    $ship_zone_id = $zone->zone_id;
                                }
                                $ab = $customer->findAddress([
                                          'customers_id' => $customer->customers_id,
                                          'entry_firstname' => $payerAddress->firstname??'',
                                          'entry_lastname' => $payerAddress->lastname??'',
                                          'entry_street_address' => $payerAddress->address_line_1??'',
                                          'entry_postcode' => $payerAddress->postal_code??'',
                                          'entry_city' => $payerAddress->admin_area_2??'',
                                          'entry_country_id' => $country['id']
                                        ]);
                                if ($ab) {
                                    $$type = $ab->address_book_id;
                                } else {
                                    $sql_data_array = array(
                                      'customers_id' => $customer->customers_id,
                                      'entry_firstname' => $payerAddress->firstname??'',
                                      'entry_lastname' => $payerAddress->lastname??'',
                                      'entry_street_address' => $payerAddress->address_line_1??'',
                                      'entry_suburb' => $payerAddress->address_line_2??'',
                                      'entry_postcode' => $payerAddress->postal_code??'',
                                      'entry_city' => $payerAddress->admin_area_2??'',
                                      'entry_country_id' => $country['id']
                                    );

                                    if ($ship_zone_id > 0) {
                                        $sql_data_array['entry_zone_id'] = $ship_zone_id;
                                        $sql_data_array['entry_state'] = '';
                                    } else {
                                        $sql_data_array['entry_zone_id'] = '0';
                                        $sql_data_array['entry_state'] = $ship_zone;
                                    }

                                    $aBook = $customer->saveAddressBook($sql_data_array);

                                    $$type = $aBook->address_book_id??null;
                                }

                                if ($type == 'sendto' && empty($billto)) {
                                    $paypal_rest->setSession('billto', $sendto);
                                } elseif ($type == 'billto' && empty($sendto)) {
                                    $paypal_rest->setSession('sendto', $billto);
                                }

                                $paypal_rest->setSession($type, $$type);
                                if (empty($customer_default_address_id)) {
                                    $customer_default_address_id = $$type;
                                    ///2do
                                    $customer_zone_id = $ship_zone_id;
                                    $customer_country_id = $country['id'];
                                }

                            }
                        }

                        if ($paypal_rest->isShippingNeeded() && isset($response->result->purchase_units[0]->shipping->options[0]->id)) {
                            $select_shipping = $response->result->purchase_units[0]->shipping->options[0]->id;
                        } else {
                            $select_shipping = 'free_free';
                        }
                        $paypal_rest->getShippingQuotesByChoice();

                        if ($customer->customers_id) {
                            $paypal_rest->setSession('customer_id', $customer->customers_id);
                        }

                        $paypal_rest->setSession('partner_order_id', $orderId);
                        $json['ok'] = true;

                        $paypal_rest->scalarToAddresses();
                        
                        if (!empty($_GET['restart']) || (!empty($_GET['page']) && $_GET['page']!='checkout')) {
                            $json['url'] = tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL');
                        } else {
                            //2check USABILITY  
                            $json['url'] = tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL');
                        }
                    } else {
                        $json['error'] = MODULE_PAYMENT_PAYPAL_REST_ORDER_DETAILS_ERROR;
                    }
                } else {
                    $json['error'] = MODULE_PAYMENT_PAYPAL_REST_ORDER_ID_ERROR;
                }
                echo json_encode($json);
                exit();
                break;

            case 'patchOrder'://for js
                try {
                    $tmp = file_get_contents("php://input");
                    $request = json_decode($tmp, true, 512, JSON_INVALID_UTF8_SUBSTITUTE);
                } catch (\Exception $e) {
                   $paypal_rest::warning(" pppPatchOrderEmptyData #### " .print_r($e->getMessage(), true), 'TLDEBUG');
                }
                if (!$request['orderID']) {
                    echo json_encode([]);
                    exit();
                    //throw new \Exception('Invalid Order ID');
                }

                $paypal_rest::warning("patchOrder \$request " . print_r($request, true), 'TLDEBUG');
                // $request contains incomplete address details (city level)
                $order = $paypal_rest->createOrderInstance();
                
                global $currency;
                $currency_code = $currency;
                if (!empty($order->info['currency'])) {
                    $currency_code = $order->info['currency'];
                }
/*                $oldSubtotal = empty($request['amount']['breakdown']['item_total']['value'])?
                    $paypal_rest->formatRaw($order->info['subtotal_inc_tax']) :
                    $request['amount']['breakdown']['item_total']['value']
                    ;
*/

                $estimateShippingChanged = true;
                if (!empty($request['shipping_address'])) {
                    $country = $paypal_rest::get_country_info_by_iso($request['shipping_address']['country_code']);
                    if ($paypal_rest->hasSession('estimate_ship')) {
                        $old = $paypal_rest->getSession('estimate_ship');
                        //2check - old is empty
                    }
                    if (!empty($old) &&
                        !empty($old['country_id']) && isset($old['postcode']) && isset($old['zone'])&& isset($old['city']) &&
                        $old['country_id'] == $country['id'] &&
                        $old['postcode'] == $request['shipping_address']['postal_code'] &&
                        $old['city'] == $request['shipping_address']['city'] &&
                        $old['zone'] == $request['shipping_address']['state']
                    ) {
                        $estimateShippingChanged = false;
                    }
                    if ($estimateShippingChanged) {
                        $paypal_rest->setSession('estimate_ship', [
                                'country_id' => $country['id'],
                                'postcode' => $request['shipping_address']['postal_code'],
                                'city' => $request['shipping_address']['city'],
                                'zone' => $request['shipping_address']['state']
                            ]);
                        $paypal_rest->setSession('estimate_bill', [
                                'country_id' => $country['id'],
                                'postcode' => $request['shipping_address']['postal_code'],
                                'city' => $request['shipping_address']['city'],
                                'zone' => $request['shipping_address']['state']
                            ]);
                    }
                } else {
                    $estimateShippingChanged = false;
                }

                if ($paypal_rest->isShippingNeeded() && $estimateShippingChanged) {
                    $paypal_rest->resetDeliveryAddress();
                } else {
                    $paypal_rest->resetBillingAddress();//2check downloadable (not required?)
                }
                
                $paypal_rest->checkoutOrderWithAddresses();

                if (!empty($request['selected_shipping_option']['id'])) {
                    $selected_shipping_option = tep_db_input(tep_db_prepare_input($request['selected_shipping_option']['id']));
                    if ($selected_shipping_option) {
                        //set selected shpping if available
                        $paypal_rest->setSelectedShipping($selected_shipping_option);
                    }
                }

                $paypal_rest->getShippingQuotesByChoice($estimateShippingChanged);


                $paypal_rest->totalProcess();

                $paypal_rest::warning('order' . print_r($paypal_rest->getOrderInstance(), true));
                $order = $paypal_rest->getOrderInstance();
                $details = $paypal_rest->getCartDetails();

                $resp = [];
//$paypal_rest::warning(" cart \$details #### " .print_r($details, true), 'TLDEBUG');
//$paypal_rest::warning(" cart \$details #### " .print_r($order, true), 'TLDEBUG');


                $resp[] = [
                            'op' => 'replace',
                            'path' => '/purchase_units/@reference_id==\'default\'/amount',
                            'value' => [
                                    'currency_code' => $currency_code,
                                    'value' => $paypal_rest->formatRaw($order->info['total']),
                                    'breakdown' => $details['totals']
                            ]
                ];


                $options = [];

                $paypal_rest->scalarToAddresses(true);
                if ($estimateShippingChanged
                    && $paypal_rest->isShippingNeeded()) {
                    $options = $paypal_rest->getShippingOptions($currencies, $currency_code);

                    if (!empty($options) && $estimateShippingChanged) {
                        $resp[] = [
                            'op' => (!empty($request['selected_shipping_option'])?'replace':'add'),
                            'path' => '/purchase_units/@reference_id==\'default\'/shipping/options',
                            'value' => $options
                        ];
                    } elseif ($paypal_rest->isShippingNeeded()) {
                        //shipping is needed but not available
                        //return [];
                        tep_exit();
                    }
                }
                /* PP docs is shit
                 https://developer.paypal.com/docs/business/javascript-sdk/javascript-sdk-reference/#onshippingchange
                 While the buyer is on the PayPal site, you can update their shopping cart to reflect the shipping address they chose on PayPal. You can use the callback to:
                 ....
                 Change the line items in the cart.
                 *
                 https://developer.paypal.com/docs/api/orders/v2/#orders_patch
                 Patchable attributes or objects:
                 *
                 no items in the list :(
                 but patchable according
                 https://www.paypal-community.com/t5/REST-APIs/v2-update-patch-Order-INVALID-JSON-POINTER-FORMAT/td-p/1833325

                 but seems only via REST (not JS) API
                 *
                * /
                if ($oldSubtotal != $paypal_rest->formatRaw($order->info['subtotal_inc_tax'])) {
                    // (not) Taxable could be selected, items subtotal changed - patch items with prices.
                    $data = [[
                                'op' => 'replace',
                                'path' => '/purchase_units/@reference_id==\'default\'',
                                'value' => [
                                    'items' => $details['items'],
                                    'amount' => [
                                              'currency_code' => $currency_code,
                                              'value' => $paypal_rest->formatRaw($order->info['total_inc_tax']),
                                              'breakdown' => $details['totals']
                                    ]
                                ]
                        ]];
                    if (!empty($options)) {
                        $data[0]['value']['shipping'] =  [
                          'options' => $options
                        ];
                    }
                    $paypal_rest->patchOrder($request['orderID'], $data);
                    //$resp = [$resp[0]];
                    $resp = $data;
                    //$estimateShippingChanged = false;
                } /* products change */

                $paypal_rest::warning("patchOrder resp " . print_r($resp, true), 'TLDEBUG');
                $paypal_rest::warning("patchOrder \$_SESSION" . print_r($_SESSION, true), 'TLDEBUG');
/** /
echo "#### <PRE>"  . __FILE__ .':' . __LINE__ . ' ' . print_r($details, true) ."</PRE>";
echo "#### <PRE>"  . __FILE__ .':' . __LINE__ . ' ' . print_r($order, true) ."</PRE>";
echo "#### <PRE>"  . __FILE__ .':' . __LINE__ . ' ' . print_r($resp, true) ."</PRE>"; die;
/**/

                echo json_encode($resp);
                tep_exit();
        }
    //}
  

  if (!$paypal_rest->check() || !$paypal_rest->enabled) {
    tep_redirect(tep_href_link(FILENAME_SHOPPING_CART, '', 'SSL'));
  }

  tep_exit();

  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
