<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2010 osCommerce

  Released under the GNU General Public License
*/

  class bm_paypal_rest {
    var $code = 'bm_paypal_rest';
    var $group = 'boxes';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function bm_paypal_rest() {
      $this->title = defined('MODULE_BOXES_PAYPAL_REST_TITLE')?MODULE_BOXES_PAYPAL_REST_TITLE:'PayPal';
      $this->description = defined('MODULE_BOXES_PAYPAL_REST_DESCRIPTION')?MODULE_BOXES_PAYPAL_REST_DESCRIPTION:'PayPal Pay Later message';

      if ( defined('MODULE_BOXES_PAYPAL_REST_STATUS') ) {
        $this->sort_order = MODULE_BOXES_PAYPAL_REST_SORT_ORDER;
        $this->enabled = (MODULE_BOXES_PAYPAL_REST_STATUS == 'True');

        $this->group = ((MODULE_BOXES_PAYPAL_REST_CONTENT_PLACEMENT == 'Left Column') ? 'boxes_column_left' : 'boxes_column_right');
      }
    }

    function execute() {
      global $cart, $currencies, $oscTemplate, $language;

      try {
        require_once(DIR_WS_LANGUAGES . $language . '/modules/payment/paypal_rest.php');
        require_once(DIR_WS_INCLUDES .  'modules/payment/paypal_rest.php');
        $paypal_rest = new paypal_rest();
        $cart_contents_string = '';

        if ($paypal_rest->checkMessageOnProduct() && !in_array($paypal_rest->currentPage(), array('checkout', 'confirmation'))) {
          if ($cart->count_contents() > 0) {
            $price = $cart->show_total();
          } else {
              $price = 0;
          }
          $cart_contents_string .= '<div class="pp-pay-later-message" style="padding:0 5px;margin:5px 0" data-pp-amount="' . $price . '" data-pp-message data-pp-style-logo-type="alternative"></div>';

          $data = '<div class="ui-widget infoBoxContainer">' .
                  //'  <div class="ui-widget-header infoBoxHeading">' . MODULE_BOXES_PAYPAL_REST_BOX_TITLE . '</div>' .
                  '  ' . $cart_contents_string .
                  $paypal_rest->checkout_initialization_method_js() .
                  '</div>';

          $oscTemplate->addBlock($data, $this->group);
        }
      } catch (\Exception $e ) {
          
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_BOXES_PAYPAL_REST_STATUS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayPal Rest Module', 'MODULE_BOXES_PAYPAL_REST_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Placement', 'MODULE_BOXES_PAYPAL_REST_CONTENT_PLACEMENT', 'Right Column', 'Should the module be loaded in the left or right column?', '6', '1', 'tep_cfg_select_option(array(\'Left Column\', \'Right Column\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_BOXES_PAYPAL_REST_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_BOXES_PAYPAL_REST_STATUS', 'MODULE_BOXES_PAYPAL_REST_CONTENT_PLACEMENT', 'MODULE_BOXES_PAYPAL_REST_SORT_ORDER');
    }
  }
?>
