<?php

  class cm_paypal_rest {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function cm_paypal_rest() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = defined('MODULE_CONTENT_PAYPAL_REST_TITLE')?MODULE_CONTENT_PAYPAL_REST_TITLE:'PayPal checkout';
      $this->description = defined('MODULE_CONTENT_PAYPAL_REST_DESCRIPTION')?MODULE_CONTENT_PAYPAL_REST_DESCRIPTION:'PayPal checkout buttons on login page';

      if ( defined('MODULE_CONTENT_PAYPAL_REST_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_PAYPAL_REST_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_PAYPAL_REST_STATUS == 'True');
      }
    }

    function execute() {
      global $messageStack, $oscTemplate;


      ob_start();
      include(DIR_WS_MODULES . 'content/' . $this->group . '/templates/paypal_rest.php');
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_PAYPAL_REST_STATUS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayPal checkout on login page', 'MODULE_CONTENT_PAYPAL_REST_STATUS', 'True', 'Do you want to enable PayPal checkout on login page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_PAYPAL_REST_CONTENT_WIDTH', 'Half', 'Should the content be shown in a full or half width container?', '6', '1', 'tep_cfg_select_option(array(\'Full\', \'Half\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_PAYPAL_REST_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_PAYPAL_REST_STATUS', 'MODULE_CONTENT_PAYPAL_REST_CONTENT_WIDTH', 'MODULE_CONTENT_PAYPAL_REST_SORT_ORDER');
    }
  }
?>
