<?php

namespace PaypalPartner;

class Installer {
    private $link = 'db_link';

    /**
     * additional DB table exists and adds if missed
     * @return bool
     */
    public function check_install() {
        $installed = self::check();
        if (!$installed) {
            self::install();
            $installed = self::check();
        }
        return $installed;
    }

/**
 * additional DB table exists
 * @global type $link
 * @param type $table
 * @return type
 */
    public function check($table = false) {
        $link = $this->link;
        global $$link;
        if (!empty($table)) {
            $tables = array($table);
        } else {
            $tables = array('paypal_seller_info', 'orders_payment');
        }
        foreach ($tables as $table) {
            $installed = mysqli_query($$link, 'select 1 from ' . $table .' LIMIT 1');
            if (!$installed) {
                break;
            }
        }
        return $installed;
    }
    
    public function install(){
        
        if (!self::check('paypal_seller_info')){
            tep_db_query("
                CREATE TABLE `paypal_seller_info` (
                `psi_id` int(11) NOT NULL AUTO_INCREMENT,
                `partner_id` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `fee_percent` float NOT NULL DEFAULT '0',
                `platform_id` int(11) NOT NULL DEFAULT '0',
                `tracking_id` varchar(127) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `email_address` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `payer_id` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_company` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_firstname` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_lastname` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_street_address` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_suburb` varchar(32) COLLATE utf8_unicode_ci DEFAULT NULL,
                `entry_postcode` varchar(10) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_city` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `entry_state` varchar(32) COLLATE utf8_unicode_ci DEFAULT NULL,
                `entry_country_id` int(11) NOT NULL DEFAULT '0',
                `entry_zone_id` int(11) NOT NULL DEFAULT '0',
                `is_onboard` int(1) NOT NULL DEFAULT '0',
                `entry_telephone` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `fee_editable` int(1) NOT NULL DEFAULT '0',
                `own_client_id` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `own_client_secret` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `paypal_partner_ccp_status` int(1) NOT NULL DEFAULT '0',
                `three_ds_settings` varchar(4096) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                `boarding_json` text COLLATE utf8_unicode_ci NOT NULL,
                `boarding_date` date NOT NULL DEFAULT '0000-00-00',
                `status` int(11) NOT NULL DEFAULT '0',
                PRIMARY KEY (`psi_id`)
               ) ENGINE=InnoDB DEFAULT CHARSET=utf8
            ");
        }
        if (!self::check('orders_payment')){
            tep_db_query("
                CREATE TABLE `orders_payment` (
                 `orders_payment_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                 `orders_payment_id_parent` int(10) unsigned NOT NULL DEFAULT '0',
                 `orders_payment_order_id` int(10) unsigned NOT NULL DEFAULT '0',
                 `orders_payment_module` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                 `orders_payment_module_name` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                 `orders_payment_is_credit` tinyint(1) NOT NULL DEFAULT '0',
                 `orders_payment_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
                 `orders_payment_amount` decimal(15,2) NOT NULL DEFAULT '0.00',
                 `orders_payment_currency` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                 `orders_payment_currency_rate` decimal(15,8) unsigned NOT NULL DEFAULT '1.00000000',
                 `orders_payment_snapshot` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
                 `orders_payment_transaction_id` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                 `orders_payment_transaction_status` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
                 `orders_payment_transaction_commentary` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                 `orders_payment_transaction_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
                 `orders_payment_admin_create` int(10) unsigned NOT NULL DEFAULT '0',
                 `orders_payment_date_create` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                 `orders_payment_admin_update` int(10) unsigned NOT NULL DEFAULT '0',
                 `orders_payment_date_update` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
                 `orders_payment_transaction_full` text COMMENT 'Payments require extra param(s) for refund, payment module should save these params in this field',
                 `credit_note_id` int(11) NOT NULL DEFAULT '0',
                 `deferred` int(4) NOT NULL DEFAULT '0',
                 PRIMARY KEY (`orders_payment_id`),
                 KEY `orders_payment_id_parent` (`orders_payment_id_parent`),
                 KEY `idx_orders_payment_date_update` (`orders_payment_date_update`),
                 KEY `idx_orders_payment_order_id` (`orders_payment_order_id`),
                 KEY `idx_orders_payment_date_transaction_id` (`orders_payment_transaction_date`,`orders_payment_transaction_id`),
                 KEY `idx_orders_payment_transaction_id` (`orders_payment_transaction_id`),
                 KEY `idx_orders_payment_module_status` (`orders_payment_module`,`orders_payment_status`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8
            ");
        }
    }
    
    public function remove($platform_id){
        if (self::check()){
            models\SellerInfo::deleteAll();
        }
    }
}