<?php
 /**
 * Transactional Midle Ware for Paypal modules
 * This file is part of osCommerce ecommerce platform.
 * osCommerce the ecommerce
 *
 * @link https://www.oscommerce.com
 * @copyright Copyright (c) 2000-2022 osCommerce LTD
 *
 * Released under the GNU General Public License
 * For the full copyright and license information, please view the LICENSE.TXT file that was distributed with this source code.
 */
namespace PaypalPartner\api;

use PayPal\Common\PayPalResourceModel;
use PayPal\Validation\ArgumentValidator;
use PayPal\Rest\ApiContext;


class Operation extends PayPalResourceModel {
    
    public function __construct($data = null){
        $this->operation = PartnerConstants::OPERATION;
        parent::__construct($data);
    }
    
    public function setApiIntegrationPreference($preference)
    {
        $this->api_integration_preference = $preference;
        return $this;
    }

    /**
     * Transactional details including the amount and item details.
     *
     * @return \PayPal\Api\Transaction[]
     */
    public function getApiIntegrationPreference()
    {
        return $this->api_integration_preference;
    }
}