<?php

trait PaypalPartnerTraitAPM {

/** @var paypal_rest  $this */

/**
 * show agreement near standard checkout button
 */
    public function apmsWithAgreement() {
        $ret = [];
        if ($this->getBillingIso2() == 'DE') {
            $ret[] = 'pui';
        }
        return $ret;
    }

/**
 * show standard checkout button (add callback)
 */
    public function apmsWithoutOwnButton() {

        $ret = ['giropay', 'sofort', 'bancontact', 'blik', 'p24', 'eps', 'ideal', 'mybank'];

        if (!empty($this->getAPMTemplate('card'))) {
            $ret[] = 'card';
        }
        if ($this->getBillingIso2() == 'DE') {
            $ret[] = 'pui';
        }
        
        return $ret;
    }
    public function getAPMTemplates() {
        $methods = $paypalMethods = [];
        $fundings = $this->getFundings();

        if (!empty($fundings['enabled'])) {
            $paypalMethods = array_map('trim', explode(',', $fundings['enabled']));
        }

        if (empty($paypalMethods)) {
            $paypalMethods = array_keys(self::$possibleFundings);
        }

        foreach ($paypalMethods as $method) {
            $methods[$method] = $this->getAPMTemplate($method);
        }

        return $methods;
    }

    public function getAPMJSCallbacks() {
        $methods = $paypalMethods = [];
        $fundings = $this->getFundings();

        if (!empty($fundings['enabled'])) {
            $paypalMethods = array_map('trim', explode(',', $fundings['enabled']));
        }

        if (empty($paypalMethods)) {
            $paypalMethods = array_keys(self::$possibleFundings);
        }

        foreach ($paypalMethods as $method) {
            $methods[$method] = $this->getAPMJSCallback($method);
        }

        return $methods;
    }
    
    public function getAPMTemplate($option) {
        global $currency;
        $ret = '';
        switch ($option) {
            case 'card':
                $platformId = $this->getPlatformId();
                $seller = $this->getSeller($platformId);

                if (!empty($seller->paypal_partner_ccp_status)) {

                    $ret = '
<style>
    .ppp_card_container .card_field {height:2em; background-color:white; border:solid #c8c8c8 1px; padding:0.5em 1em;}
</style>
<div class="ppp_card_container">
    <div id="ppp-card-form" class="ppp-cc-field">
        <label for="ppp-card-number">' . MODULE_PAYMENT_PAYPAL_REST_TEXT_CC_NUMBER . '</label>
        <div id="ppp-card-number" class="card_field"></div>
    </div>
    <div class="ppp-cc-field">
        <label for="ppp-expiration-date">' . MODULE_PAYMENT_PAYPAL_REST_TEXT_EXP . '</label>
        <div id="ppp-expiration-date" class="card_field"></div>
    </div>
    <div class="ppp-cc-field">
        <label for="ppp-cvv">' . MODULE_PAYMENT_PAYPAL_REST_TEXT_CVV . '</label>
        <div id="ppp-cvv" class="card_field"></div>
    </div>
</div>
                    ';
                }
            break;

            case 'pui':
                $ret = '';
                if ($currency =='EUR' && $this->getBillingIso2() == 'DE') {
/* osc23 - phone and birthday are required
                    $showPhone = $showBirthDay = false;
                    if ($this->isCustomerAssigned()) {
                        $cust = $this->getCustomersIdentity();
                        if ($cust && substr($cust->customers_dob, 0, 4) > 1900) {
                            $showBirthDay = false;
                        }
                    }

                    $platformId = $this->getPlatformId();
                    if ($showPhone || $showBirthDay ) {
                        $ret = '
<style>
    .ppp_pui .pui_field input {position: initial;}
    .inline-block.paypal-marks-icon.paypal-marks-icon-pui {display:none}
    #ppp-pui-bd:after{content: \'\';display: block;clear: both;}
    #ppp-pui-bd-container {position: absolute; z-index: 100;background:#fff; }
    #ppp-pui-bd-container > div {border: 1px solid #999;}
</style>
<div class="ppp_pui">';
                        if ($showBirthDay) {
                            $ret .= '
    <div class="ppp-pui">
        <label for="ppp-pui-bd">' . ENTRY_DATE_OF_BIRTH . '</label>
        <div id="ppp-pui-bd" class="pui_field" style="position: relative;">' . \common\helpers\Html::textInput('paypal_birthday', '', ['placeholder' => date(DATE_FORMAT_DATEPICKER_PHP), 'class' => 'form-control datepicker pay-later-birthday']) . '</div>
            <div id="ppp-pui-bd-container"></div>
    </div>';
                        }
                        if ($showPhone) {
                            $ret .= '
    <div class="ppp-pui">
        <label for="ppp-pui-phone">' . ENTRY_TELEPHONE_ADRESS_BOOK . '</label>
        <div id="ppp-pui-phone" class="pui_field">' . \common\helpers\Html::textInput('paypal_telephone', '', ['class' => 'form-control', 'minlength' => 5]) . '</div>
    </div>';
                        }
                        $ret .= '
</div>
                        ';
                    }*/
                }
            break;
            case '_ideal':
                $ret .= '
                    <div class="ppp-ideal" id="ppp-ideal"></div>
                        ';
            break;
        }
        return $ret;
    }

    public function getAPMJSCallback($option) {
        $ret = '';
        //$createUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'createOrder', 'option' => $option]);
        $getCCOptionsUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'customerDetails', 'option' => $option]);
        $retrieveUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'retrieveOrder']);
        $generalError = str_replace(["'", "\n"], ["\\'", '<br>'], defined('MODULE_PAYMENT_PAYPAL_REST_TEXT_ERROR_CAPTURE')?MODULE_PAYMENT_PAYPAL_REST_TEXT_ERROR_CAPTURE:'Payment could not be captured.');
        $generalErrorModule = str_replace(["'", "\n"], ["\\'", '<br>'], defined('MODULE_PAYMENT_PAYPAL_REST_GENERAL_ERROR') ? MODULE_PAYMENT_PAYPAL_REST_GENERAL_ERROR : "Can't create order");
        switch ($option) {
            case 'card':
                $threeDS = 1;
                $platformId = $this->getPlatformId();
                $seller = $this->getSeller($platformId);
                if (!empty($seller->three_ds_settings)) {
                    $settings = json_decode($seller->three_ds_settings, true);
                }
                if (empty($settings['status'])) {
                    $threeDS = 0;
                }
                $ret =
        "window.{$this->code}_callback_{$option} = function () {
            ///get billing details
            var bodyData = '';
            if (paymentCollection.form) {
                bodyData = $(paymentCollection.form).serialize();
            }
            $.ajax({
                url: '{$getCCOptionsUrl}',
                data: bodyData,
                async: false,
                type: 'POST',
                dataType: 'json',
                success: function(data){

                    paymentCollection.pppCardFields.submit(data)
                    .then(function (payload) {
//https://developer.paypal.com/docs/checkout/advanced/customize/3d-secure/response-parameters/
//https://developer.paypal.com/docs/checkout/advanced/customize/3d-secure/test/
                        /** sample payload
                        {
                        liabilityShifted: false, liabilityShift: \"NO\", authenticationStatus: \"ERROR\", authenticationReason: \"ERROR\", card: undefined, orderId: \"7GV78070L0698402K\"
                        }
                        */
    console.log(payload);
                        // Needed only when 3D Secure contingency applied
                        if (payload.liabilityShift === 'POSSIBLE') {
                             // 3D Secure passed successfully
                             return payload;
                        }
                        if (payload.liabilityShifted) { //payload.liabilityShift in docs
                             // Handle buyer confirmed 3D Secure successfully
                             return payload;
                        }
                        if ({$threeDS} && payload.authenticationStatus == 'APPROVED'){
                             return payload;
                        }
                        /**/
                        //pppOrderId = payload.orderId;
                        return false;
                    })
                    .then((payload) => {
                        if (payload && payload.orderId){
                            pppOrderId = payload.orderId;
                            $('body').append('<div class=\"hide-page\" style=\"align-items: center;background-color: rgba(255, 255, 255, 0.7);height:100%; justify-content: center; left:0; position: fixed; top:0; width:100%; z-index: 100000; display:flex;\"><div class=\"preloader\"></div></div>');
                            return fetch('{$retrieveUrl}&id=' + pppOrderId, {
                                method: 'POST'
                            }).then(function(res) {
                                return res.json();
                            }).then(function(res) {
                                if (!res.ok) {
                                    $('.hide-page').remove();
                                    alertMessage(res.error);
                                } else {
                                    window.location.href = res.url;
                                }
                            });
                        } else {
                            alertMessage('$generalError');
                        }
                    })
                    .catch((err) => {
                        $('.hide-page').remove();
                        var msg = '';
                        try {
                            msg = err.details[0].description;
                        } catch ( e ) { }
                        if (msg == '') {
                            msg = JSON.stringify(err);
                            if (msg == '{}') msg = '';
                        }
                        alertMessage('$generalError ' + msg);
                    });

                }
            });
        }
";
          break;
            case 'pui':
                if ($this->getBillingIso2() == 'DE') {
                    $createUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'createOrder', 'option' => $option, 'page' =>$this->currentPage()]);
                    $ret = "
        window.{$this->code}_callback_{$option} = function () {
            var bodyData = '';
            if (paymentCollection.form) {
                bodyData = $(paymentCollection.form).serialize();
            }
            $.ajax({
                url: '{$createUrl}',
                data: bodyData,
                async: false,
                dataType: 'json',
                type: 'POST',
                success: function(data){
                    pppOrderId = '';
                    try {
                        if (data.hasOwnProperty('error') && data.error ) {
                            if (data.hasOwnProperty('message') ) {
                                alertMessage(data.message);
                            } else {
                                alertMessage('$generalErrorModule');
                            }
                        } else {
                            pppOrderId = data.id;
                        }
                    } catch ( e ) {
                      console.log(e);
                      return false
                    }
                    if (pppOrderId != false) {
                        $('body').append('<div class=\"hide-page\" style=\"align-items: center;background-color: rgba(255, 255, 255, 0.7);height:100%; justify-content: center; left:0; position: fixed; top:0; width:100%; z-index: 100000; display:flex;\"><div class=\"preloader\"></div></div>');
                        return fetch('{$retrieveUrl}&id=' + pppOrderId, {
                            method: 'POST'
                        }).then(function(res) {
                            return res.json();
                        }).then(function(res) {
                            if (!res.ok) {
                                $('.hide-page').remove();
                                alertMessage(res.error);
                            } else {
                                window.location.href = res.url;
                            }
                        });
                    }
                }
            })
        }
";
                }
          break;
            case 'giropay':
            case 'bancontact':
            case 'blik':
            case 'p24':
            case 'eps':
            case 'mybank':
            case 'sofort':
            case 'ideal':
                if (true || $this->validAPMCountry($option, $this->getBillingIso2())) {
                    $createUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'createOrder', 'page' =>$this->currentPage(), 'option' => $option]);
                    $ret = "
        window.{$this->code}_callback_{$option} = function () {
            var bodyData = '';
            if (paymentCollection.form) {
                bodyData = $(paymentCollection.form).serialize();
            }
            $.ajax({
                url: '{$createUrl}',
                data: bodyData,
                async: false,
                dataType: 'json',
                type: 'POST',
                success: function(data){
                    pppOrderId = '';
                    try {
                        if (data.hasOwnProperty('error') && data.error ) {
                            if (data.hasOwnProperty('message') ) {
                                alertMessage(data.message);
                            } else {
                                alertMessage('$generalErrorModule');
                            }
                        } else {
                            pppOrderId = data.id;
                            window.location.href = data.url;
                        }
                    } catch ( e ) {
                      console.log(e);
                      return false
                    }
                }
            })
        }
";
                }
          break;

        }
        return $ret;
    }

/**
 * paranoic - could be return true; (PayPal should return error if APM is not available for country/currency)
 * need to be updated if APM became available for new country
 * @param string $option APM
 * @param string $code country ISO 2 code
 * @return bool
 */
    protected function validAPMCountry($option, $code){
        $ret = false;
        switch ($option) {
            case 'bancontact':
                $ret = in_array($code, ['BE']);
                break;
            case 'blik':
            case 'p24':
                $ret = in_array($code, ['PL']);
                break;
            case 'eps':
                $ret = in_array($code, ['AT']);
                break;
            case 'giropay':
                $ret = in_array($code, ['DE']);
                break;
            case 'ideal':
                $ret = in_array($code, ['NL']);
                break;
            case 'mybank':
                $ret = in_array($code, ['IT']);
                break;
            case 'sofort':
                $ret = in_array($code, ['AT', 'BE', 'DE', 'SP', 'IT', 'NL', 'GB']);
                break;
        }
        return $ret;
    }
    
    public function getAPMJS($option) {
        $ret = '';
        $createUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'createOrder', 'option' => $option, 'page' =>$this->currentPage()]);
        $getCreateUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'createOrder', 'option' => $option, 'get' => 1, 'page' =>$this->currentPage()]);
        $retrieveUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'retrieveOrder']);
        $shippingUrl = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'action' => 'patchOrder']);
        $customersDetails = '';
        if (!$this->getCustomerAssigned()) {
            //2do 'frmCheckoutConfirm' : 'frmCheckout'
            $customersDetails = ",{
                                method: 'POST',
                                headers: {'Content-Type':'application/x-www-form-urlencoded'},
                                body: $('#frmCheckout').serialize()
                            }";
        }
        
        switch ($option) {
            case 'pui': //upon invoice
                if ($this->getBillingIso2() == 'DE') {
                    //$bsdpjs = \frontend\design\Info::themeFile('/js/bootstrap-datepicker.js');
                    $ret = "
    window.paypal_render_subfields_{$option} = function () {
        try {
            var pppPUIbdcnt = 0; pppPUIbd = window.setInterval(function() {
                if (false && $('.pay-later-birthday:visible').length==0 || typeof($.fn.datepicker.version)=='undefined') {
                    pppPUIbdcnt++;
                    if (pppPUIbdcnt>5) { //seems jquery datepicker only - load bootstrap
                        (function(d, s, id){
                        var js, ref = d.getElementsByTagName(s)[0]; if (!d.getElementById(id)){
                        js = d.createElement(s); js.id = id; js.async = true;
                        js.src = '" . $bsdpjs . "';
                        ref.parentNode.insertBefore(js, ref); }
                        }(document, 'script', 'bsdpjs'));
                    }
                    if (pppPUIbdcnt>50){ //sorry cant load bootstrap datepicker
                        window.clearInterval(pppPUIbd);
                    }
                    return false;
                }
                window.clearInterval(pppPUIbd);
                
                $('.pay-later-birthday:visible').not('.dp-inited').datepicker({
                    startView: 3,
                    format: '" . JQUERY_DATEPICKER_FORMAT . "',
                    language: 'current',
                    autoclose: true,
                    container:$('#ppp-pui-bd-container')
                });
                $('.pay-later-birthday:visible').addClass('dp-inited');
            }, 500);
        } catch ( e ) { console.log(e); }
    }
    ";
                }
                break;
            case 'card':
                $platformId = $this->getPlatformId();
                $seller = $this->getSeller($platformId);
                if (!empty($seller->paypal_partner_ccp_status)) {
                    $ret = "
window.paypal_render_subfields_{$option} = function () {
    if (paypal.HostedFields.isEligible()) {
         let pppOrderId;
        // Renders card fields
        if (paymentCollection && !paymentCollection.hasOwnProperty('pppCardFields')) {
            paypal.HostedFields.render({
              createOrder: () => {
                return fetch('{$createUrl}' {$customersDetails}
                ).then((res) => res.json())
                .then((orderData) => {
                  pppOrderId = orderData.id; // needed later to complete capture
                  return orderData.id
                })
              },
              styles: {
                '.valid': {
                  color: 'green'
                },
                '.invalid': {
                  color: 'red'
                }
              },
              fields: {number: {selector: '#ppp-card-number', placeholder: '4111 1111 1111 1111'},
                cvv: {selector: '#ppp-cvv', placeholder: '123' },
                expirationDate: {selector: '#ppp-expiration-date', placeholder: '" . MODULE_PAYMENT_PAYPAL_REST_TEXT_EXP_PLACEHOLDER . "' }
              }
            }).then((cardFields) => {
              if (!paymentCollection.hasOwnProperty('pppCardFields')) {
                  paymentCollection.pppCardFields = cardFields;
              }

            });
        }

    } else {
        $('.item-radio.item-payment.{$this->code}_card').hide();
    }
}
";
                }
          break;
        }
        return $ret;
    }

    public function setAPMSetting($post) {
        $payment = $post['payment'];
        if (in_array($payment, ['paypal_rest_pui'])) {
            $this->requireItemVat = true;
        }

    }

    public function addAPMDetails(&$request, $order, $post) {
        $payment = $post['payment'];
        //pay upon invoice available in DE and requires EN|DE-DE locale
        $locale = $this->getLocale();
        $country_code = false; //it could be in payer - if customer is logged in?? or in shipping if guest
        if (!empty($request->body['payer'])) {
            $payer = $request->body['payer'];
        } elseif ($request->body['payment_source']['paypal']) {
            $payer = $request->body['payment_source']['paypal'];
        } else {
            // generally error
            $payer = [];
        }

        if (!empty($payer['address']['country_code'])) {
            $country_code = $payer['address']['country_code'];
        } elseif (!empty($request->body['purchase_units'][0]['shipping']['address']['country_code'])) {
            $country_code = $request->body['purchase_units'][0]['shipping']['address']['country_code'];
        }

        if ($country_code == 'DE' && substr($locale, -2) != 'DE') {
            $locale = substr($locale , 0, -2) . 'DE';
        }

        $fullname = '';
        if (!empty($payer['name'])) {
            $fullname = ($payer['name']['given_name']??null) . ' ' . ($payer['name']['surname']??null);
        } elseif (!empty($request->body['purchase_units'][0]['shipping']['name']['full_name'])) {
            $fullname = $request->body['purchase_units'][0]['shipping']['name']['full_name'];
        }
        $email_address = '';
        if (!empty($payer['email_address'])) {
            $email_address = $payer['email_address'];
        }
        switch ($payment) {
            case 'paypal_rest_card':
                //unset($request->body['payment_source']);
                break;
            case 'paypal_rest_pui':
                if ($request->body['intent']=='CAPTURE' &&  $country_code == 'DE') {
                    $dob = $telephone = '';
                    $prefix = preg_replace('/\D/', '', $this->billing['country']['dialling_prefix']);
                    if (!empty($post['checkout']['telephone'])) {
                        $telephone = $post['checkout']['telephone'];

                    } elseif (!empty($post['paypal_telephone'])) {
                        $telephone = $post['paypal_telephone'];
                    }
                    $telephone = preg_replace('/\D/', '', $telephone);
                    if ($prefix == substr($telephone, 0, strlen($prefix))){
                        $telephone = substr($telephone, strlen($prefix));
                    }

                    if (!empty($post['paypal_birthday'])) {
                        $dob = \common\helpers\Date::prepareInputDate($post['paypal_birthday']);

                    } elseif ($this->isCustomerAssigned()) {
                        $cust = $this->getCustomersIdentity();
                        if ($cust && substr($cust->customers_dob, 0, 4)>1900) {
                            $dob = substr($cust->customers_dob, 0, 10);
                        }
                    }
       
                    $payment_source =  [
                                "pay_upon_invoice" =>
                                [
                                    'name' => $payer['name']??null,
                                    'email' => $payer['email_address']??$email_address,
                                    'billing_address' => $payer['address']??null,
                                    'birth_date' => $dob,
                                    'phone' => [
                                      'national_number' => $telephone,
                                      'country_code' => $prefix
                                    ],
                                    'experience_context' => [
                                      'locale' => $locale,
                                      'customer_service_instructions' => [TEXT_INVOICE_SOMETHING_WRONG . ' ' . STORE_OWNER_EMAIL_ADDRESS]
                                    ]

                                ]

                    ];
                    $request->body['payment_source'] = $payment_source;
                    $request->body['processing_instruction'] = "ORDER_COMPLETE_ON_PAYMENT_APPROVAL";
                }
            break;
            case 'paypal_rest_giropay':
            case 'paypal_rest_bancontact':
            case 'paypal_rest_blik':
            case 'paypal_rest_p24':
            case 'paypal_rest_eps':
            case 'paypal_rest_mybank':
            case 'paypal_rest_sofort':
            case 'paypal_rest_ideal':
                $_option = str_replace('paypal_rest_', '', $payment);
                if ($request->body['intent']=='CAPTURE') {
                    $payment_source =  [
                                "$_option" =>
                                [
                                    'name' => ($payer['name']['given_name']??null) . ' ' . ($payer['name']['surname']??null),
                                    'country_code' => $country_code
                                ]

                    ];
                    if (in_array($_option, ['blik', 'sofort', 'p24'])){
                        $payment_source[$_option]['email'] = $payer['email_address'];
                    }
                    /*if (in_array($_option, ['ideal'])){
                        $payment_source[$_option]['bic'] = $post['paypal_rest_bic'];
                    }*/
                    $request->body['payment_source'] = $payment_source;
                    $request->body['processing_instruction'] = "ORDER_COMPLETE_ON_PAYMENT_APPROVAL";
                    
                    $request->body['application_context']['return_url'] = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'method' => $_option, 'action' => 'returnAPM'], 'SSL', true);
                    $request->body['application_context']['cancel_url'] = $this->createAbsoluteUrl(["ext/modules/payment/paypal_rest/index.php", 'method' => $_option, 'action' => 'cancelAPM'], 'SSL', true);

                    $this->redirectMethodsBeforeLeave($request);
                }
            break;
        }


    }

/**
 * process return from APM
 * @param string $method
 */
    public function returnAPM($method) {
        if ($this->saveOrderBefore() == 'Order' ) {
            if ($this->hasSession('ppp_order_before')) {
                $orders_id = $this->getSession('ppp_order_before');
            }
        } else {
            //false && tmp order - convert to real one, webhook will do the same :(
            // use child_id as a lock flag (-1)
            if ($this->hasSession('ppp_tmp_order')) {
                $tmp_order_id = substr($this->getSession('ppp_tmp_order'), 3);//'tmp' . $ret;
                if ($this->lockTmpOrder($tmp_order_id)) {
                    $tmpOrder = $this->manager->getParentToInstanceWithId('\common\classes\TmpOrder', $tmp_order_id);
                    /// not verified !!! $tmpOrder->info['order_status'] = $this->paidOrderStatus();
                    $orders_id = $tmpOrder->createOrder();
                    $order = $this->getOrderInstanceWithId($orders_id);

                    $this->no_process($order);

                    //$order->notify_customer($order->getProductsHtmlForEmail(),[]);
                    
                    $this->no_process_after($order);

                } else {
                    sleep(2);
                    $orders_id = \common\models\TmpOrders::find()->where(['orders_id' => $tmp_order_id, 'child_id' => 0])
                        ->select('child_id')
                        ->scalar();
                }
            } elseif ($this->hasSession('ppp_order_before')) {
                $orders_id = $this->getSession('ppp_order_before');
            }
        }
        if ($orders_id) {
            $this->resetSession('ppp_order_before');
            if (!empty($_GET['token'])) {
                $order = $this->getOrderInstanceWithId($orders_id);
                $response = $this->getOrder($_GET['token']);
                self::debug(" #### " .print_r($response, true), 'TLDEBUG');
                if (!empty($response->result)) {
                    $pp_result = [];
                    if ($response->result->payment_source) {
                        $keys = array_keys((array)$response->result->payment_source);
                        $pp_result[] = tep_output_string_protected(implode(',', $keys));
                    }
                    if ($response->result->id) {
                        $pp_result[] = 'Internal Order ID: ' . tep_output_string_protected($response->result->id);
                    }
                    if ($response->result->status) {
                        $pp_result[] = 'Payment Status: ' . tep_output_string_protected($response->result->status);
                    }
                    $sql_data_array = array('orders_id' => $order->info['orders_id'],
                        'orders_status_id' => $order->info['order_status'],
                        'date_added' => 'now()',
                        'customer_notified' => '0',
                        'comments' => implode("\n", $pp_result));
                    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                }
            }

            global $cart;
            $cart->reset(true);
            tep_session_unregister('sendto');
            tep_session_unregister('billto');
            tep_session_unregister('shipping');
            tep_session_unregister('payment');
            tep_session_unregister('comments');
            //$this->resetSession('order');

            $url = $this->createAbsoluteUrl(['checkout_success.php', 'order_id' => $orders_id]);
            
        } else {
            //redirect to account history page with a message
            global $messageStack;
            $messageStack->add_session(SESSION_EXPIRED_LOGIN_OR_CHECK_EMAIL, 'account', 'warning');
            $url = $this->createAbsoluteUrl(['account_history.php']);
            
        }
        $this->scalarToAddresses();
        tep_redirect($url);
    }
    
    public function cancelAPM($method) {
        if (($this->saveOrderBefore() == 'Order' || $this->saveOrderBefore()===false) && $this->hasSession('ppp_order_before')) {
            //cancel real order if it's created according settings.
            $orders_id = $this->getSession('ppp_order_before');
            $order = $this->getOrderInstanceWithId( $orders_id);
            $this->resetSession('ppp_order_before');
            if (!empty($_GET['token'])) {
                $order = $this->getOrderInstanceWithId($orders_id);
                $response = $this->getOrder($_GET['token']);
                
                self::debug('response ' . print_r($response, true), 'cancelAPM');
                if (!empty($response->result)) {
                    $pp_result = [];
                    if ($response->result->payment_source) {
                        $keys = array_keys((array)$response->result->payment_source);
                        $pp_result[] = tep_output_string_protected(implode(',', $keys));
                    }
                    if ($response->result->id) {
                        $pp_result[] = 'Internal Order ID: ' . tep_output_string_protected($response->result->id);
                    }
                    if ($response->result->status) {
                        $pp_result[] = 'Payment Status: ' . tep_output_string_protected($response->result->status);
                    }
                    $sql_data_array = array('orders_id' => $order->info['orders_id'],
                        'orders_status_id' => $order->info['order_status'],
                        'date_added' => 'now()',
                        'customer_notified' => '0',
                        'comments' => implode("\n", $pp_result));
                    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                }
            }

            /*$order_status = $this->refundOrderStatus();//2do
            if (!$this->isPartlyPaid() && (int)$order_status>0 && $order_status != $order->info['order_status']) {
                \common\helpers\Order::setStatus($order->order_id, (int)$order_status, [
                    'comments' => TEXT_CANCELLED_BY_CUSTOMER,
                    'customer_notified' => 0,
                ]);
            }*/
        }
        $this->scalarToAddresses();
        tep_redirect($this->getCheckoutUrl(['error_message' => MODULE_PAYMENT_PAYPAL_REST_PROCESSING_ERROR], self::PAYMENT_PAGE));
    }

/**
 * save tmp/live order and set its ID as invoice id in the create order request (to PayPal)
 * @param type $request
 */
    public function redirectMethodsBeforeLeave(&$request) {
        try {
            $invoiceId = $this->checkSaveTmpOrder();
        } catch (\Exception $e) {
            self::warning(" #### " .print_r($e->getMessage() . ' ' . $e->getTraceAsString(), true), 'exception_' . $this->code);
        }
        $request->body['purchase_units'][0]['invoice_id'] = $invoiceId;

    }
    
    public function validateAPMCreateOrderResponse($method, $pRes) {
        $response['id'] = $pRes->result->id;
        $response['option'] = $method;
        switch ($method) {
            case 'giropay':
            case 'sofort':
            case 'bancontact':
            case 'blik':
            case 'p24':
            case 'eps':
            case 'ideal':
            case 'mybank':
                if ($pRes->result->status == 'PAYER_ACTION_REQUIRED' && !empty($pRes->result->payment_source->$method)) {
                    $url = false;
                    if (!empty($pRes->result->links) && is_array($pRes->result->links)) {
                        foreach($pRes->result->links as $link) {
                            if ($link->rel == 'payer-action') {
                                $url = $link->href;
                                break;
                            }
                        }
                    }
                    if ($url) {
                        //nice2have move create order here and update invoiceID
                        $response['url'] = $url;
                    } else {
                        $response = ['error' => 1, 'message' => TEXT_UNEXPECTED_PAYMENT_ERROR . ' ' . '(NO_REDIRECT_URL)'];
                        self::warning("NO_REDIRECT_URL #### " .print_r($pRes, true), 'TLDEBUG' . $this->code);
                    }
                } else {
                    $response = ['error' => 1, 'message' => TEXT_UNEXPECTED_PAYMENT_ERROR . ' ' . '(UNEXPECTED_STATUS)'];
                    self::warning("UNEXPECTED_STATUS #### " .print_r($pRes, true), 'TLDEBUG' . $this->code);
                }
                break;
            case 'card':
            case 'pui':
                break;
            default:
                $response = ['error' => 1, 'message' => TEXT_UNEXPECTED_PAYMENT_ERROR . ' ' . '(UNEXPECTED_METHOD)'];
                self::warning("UNEXPECTED_METHOD #### " .print_r($pRes, true), 'TLDEBUG' . $this->code);
                break;
        }
        return $response;
        
    }


    public static function getFundingTitle($option) {
        $data = self::$possibleFundings[$option];
        return (defined($data['translation_key'])? constant($data['translation_key']):$data['default_translation']);
    }

    public static function possibleFundingArray() {
        $ret = ['all' => '<span class="paypal-partner-pm">' . (defined('TEXT_ALL')?TEXT_ALL:'All') . '</span>'];

        $platformISO2 = ''; 
        
        $cinfo = self::get_country_info_by_id();
        if (!empty($cinfo)) {
            $platformISO2 = strtolower($cinfo['countries_iso_code_2']);
        }

        foreach (self::$possibleFundings as $k => $data) {
            $countries = $classes = '';
            if ($data['apm']) {
                $classes .= ' apm';
            }
            if (!empty($data['countries']) && is_array($data['countries'])) {
                $applicable = false;
                foreach ($data['countries'] as $country) {
                    $country = strtolower($country);
                    if ($platformISO2 == $country) {
                        $applicable = true;
                    }
                    $classes .= ' ' . $country;
                    $countries .= '<span class="' . $country . '"></span>';
                }
                if ($applicable) {
                    $classes .= ' applicable';
                } else {
                    $classes .= ' not-applicable';
                }
            }

            $ret[$k] = '<span class="paypal-partner-pm' . $classes . ' flag">' . $countries .
                self::getFundingTitle($k) .
                '</span>';
        }
        return $ret;
    }
}
